
/********** normalize a vector **************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "invsubs.h"

/* values from sun's values.h file */

#define MYMAXFLOAT        ((float)3.40282346638528860e+38)
#define MYMINFLOAT        ((float)1.40129846432481707e-45)

void Normalize(float *vector, int dim, float *length)
{
	float           sum, scaler;
	int             i;

	sum = 0.0;
	for (i = 1; i <= dim; i++)
		sum = sum + (vector[i] * vector[i]);
		
	if(sum < 0){
		fprintf(stderr,"Message from Normalize:\n");
		fprintf(stderr,"Sum of Squares < 0 - probably =0 with roundoff.\n");
		exit(-1);
	}
	
	if(sum >= MYMAXFLOAT){
		fprintf(stderr,"Message from Normalize:\n");
		fprintf(stderr,"Warning Sum of Squares >= MYMAXFLOAT  roundoff.\n");
		fprintf(stderr,"sum = %e\n",sum);
	}
	
	*length = sqrt((double) sum);

	if(*length < MYMINFLOAT){
		fprintf(stderr,"Message from Normalize:\n");
		fprintf(stderr,"Normalizing by a number less than %.2e\n",MYMINFLOAT);
		exit(-1);
	}
	
	scaler = 1.0 / *length;

	for (i = 1; i <= dim; i++)
		vector[i] *= scaler;

}
